#include <iostream>

using namespace std ;


#include "functions.h"
// Everything is in the rcs namespace...

// This main is intended to be stepped through with the debugger...
int main()
{
    cout << "running" ;
    //////////// Call the function overloads ////////////////
    float x=1.0f ;   // 1.0f means "1.0 as a single precision float"
    float y=2.0f ;
    float z=4.0 ;    // The compiler will auto-convert 4.0 to a float.
    float a=rcs::average3(x,y,z) ;
    // Try with some integers
    auto q = rcs::average3(1,3,4) ;

    // What happens if we mix integer and single-precision floats?
    // Uncomment and re-compile
    //auto w = rcs::average3(1,3.0f, 4.0f) ;

    // What happens if we uncomment this line and try to
    // compile?  20.34 is a double-precision value.
    auto e = rcs::average3(10,-8, 20.34) ;


    //////////// Call the templated sum function
    // Usual syntax:
    z = rcs::avg3_template<float>(x,y,z) ;
    //  But if the compiler can figure out you mean <float>
    // you can skip it.
    z = rcs::avg3_template(x,y,z) ;
    // Integer version
    q = rcs::avg3_template<int>(1,3,4) ;

    // What about mixed types with the template?
    //rcs::avg3_template<int>(1,3.0f,4) ;

    return 0;
}
